import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkIntegralLog, ThinkIntegralLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkIntegralLog(params: ThinkIntegralLogParam) {
  const res = await request.get<ApiResult<PageResult<ThinkIntegralLog>>>(
    THINK_API_URL + '/think/think-integral-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkIntegralLog(params?: ThinkIntegralLogParam) {
  const res = await request.get<ApiResult<ThinkIntegralLog[]>>(
    THINK_API_URL + '/think/think-integral-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkIntegralLog(data: ThinkIntegralLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-integral-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkIntegralLog(data: ThinkIntegralLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-integral-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkIntegralLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-integral-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkIntegralLog(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-integral-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkIntegralLog(id: number) {
  const res = await request.get<ApiResult<ThinkIntegralLog>>(
    THINK_API_URL + '/think/think-integral-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
